#include "CheckBoxHeaderView.h"
#include "GlobalDef.h"
#include <QtWidgets/QCheckBox>
#include <QMouseEvent>
#include <QDebug>

CheckBoxHeaderView::CheckBoxHeaderView(Qt::Orientation orientation, QWidget*  parent)
    : QHeaderView(orientation, parent)
{
    m_state = 0;
    m_mousePoint.setX(100);
    m_mousePoint.setY(100);
}

// 槽函数，用于更新复选框状态
void CheckBoxHeaderView::slot_stateChanged(int state)
{
    m_state = state;
    updateSection(0);
    repaint();
}

// 绘制复选框
void CheckBoxHeaderView::paintSection(QPainter *painter, const QRect &rect, int logicalIndex) const
{
    painter->save();
    QHeaderView::paintSection(painter, rect, logicalIndex);
    painter->restore();
    if (logicalIndex == 0)//第一列
    {
        //保存第一列的位置
        m_RectHeaderCheckBox.setX(rect.x() + 3);
        m_RectHeaderCheckBox.setY(rect.y() + 10);
        m_RectHeaderCheckBox.setWidth(14);
        m_RectHeaderCheckBox.setHeight(14);
        QStyleOptionButton option;
        QPixmap pix;
        if (g_bAdmPrivilege)
        {
            if (m_state == 2)
            {//图片需要在资源里添加
                pix.load(":/images/image/all_checked.png");//选中
                option.state = QStyle::State_On;
            }
            else if (m_state == 1)
            {
                pix.load(":/images/image/partial_checked.png");//高亮
                option.state = QStyle::State_HasFocus;
            }
            else
            {
                pix.load(":/images/image/all_uncheked.png");//正常
                option.state = QStyle::State_Off;
            }
        }
        else
        {
            pix.load(":/images/image/disable_num3.png");//正常
            option.state = QStyle::State_Off;
        }
        option.rect = rect;
        style()->drawItemPixmap(painter, rect, Qt::AlignCenter, pix);        
    }
}

// 鼠标按下表头
void CheckBoxHeaderView::mousePressEvent(QMouseEvent *event)
{
    //表头可控制，鼠标第一个列，鼠标在矩形范围内    
    if (visualIndexAt(event->pos().x()) == 0 && g_bAdmPrivilege)
    {

        if (m_state != 2)
            m_state = 2;
        else
            m_state = 0;

        updateSection(0);//刷新表头第一列

        emit signal_stateChanged(m_state);

    }

    emit signal_clickedSection(visualIndexAt(event->pos().x()));
    QHeaderView::mousePressEvent(event);
    //repaint();
}

//void CheckBoxHeaderView::mouseMoveEvent(QMouseEvent *event)
//{
//    //保存鼠标的位置

//    m_mousePoint = event->pos();

//    if (m_RectHeaderCheckBox.contains(m_mousePoint))

//    {

//        updateSection(0);//重绘表头复选框

//    }

//    QHeaderView::mouseMoveEvent(event);
//}
