#ifndef CHECKBOXHEADERVIEW_H
#define CHECKBOXHEADERVIEW_H


#include <QtWidgets/QHeaderView>
#include <QPainter>
class CheckBoxHeaderView : public QHeaderView
{
    Q_OBJECT
public:
    //构造函数， 第一个参数设定表头方向
    explicit CheckBoxHeaderView(Qt::Orientation orientation, QWidget* parent = 0);

protected:
    void paintSection(QPainter *painter, const QRect &rect, int logicalIndex) const;

    void mousePressEvent(QMouseEvent *event);

    //void mouseMoveEvent(QMouseEvent *event);

public slots:
    // 槽函数，用于更新复选框状态
    void slot_stateChanged(int state);

signals:
    void signal_stateChanged(int state);

    void signal_clickedSection(int index);

private:
    int m_state;
    QPoint m_mousePoint;//鼠标位置
    mutable QRect m_RectHeaderCheckBox;//复选框的位置
};

#endif // CHECKBOXHEADERVIEW_H
