#ifndef FILTERSELECTDIALOG_H
#define FILTERSELECTDIALOG_H

#include <QtWidgets/QDialog>
#include <QMap>
#include <QStringList>
#include <QtWidgets/QVBoxLayout>
#include <QtWidgets/QHBoxLayout>
#include <QtWidgets/QPushButton>
#include <QtWidgets/QCheckBox>
#include <QtWidgets/QFrame>

enum filter_types
{
    filter_execctrl_type = 0,
    filter_execctrl_status,
    filter_fileprotect_status,
    filter_kmodprotect_status
};

class FilterSelectDialog : public QDialog
{
    Q_OBJECT
public:
    explicit FilterSelectDialog(filter_types type, QWidget *parent = 0);
    void getFilterItems(QMap<int, bool> &filters);
    void setFilterItems(QMap<int, bool> filters);

private:
    void initUI();
    void initCheckBoxs(QVBoxLayout* pLayout);

protected:
    void mousePressEvent(QMouseEvent *event);

private slots:
    void slot_applyBtnClicked();
    void slot_cancelBtnClicked();
private:
    QMap<int, bool> m_filters;
    QVBoxLayout* m_pVBoxLayout;
    QHBoxLayout* m_pHBoxLayout;
    QPushButton* m_pApplyBtn;
    QPushButton* m_pCancelBtn;
    QList<QCheckBox*> m_checks;

    QFrame* m_pSplitLine;

    filter_types m_type;
};

#endif // FILTERSELECTDIALOG_H
