#include "FlatDropWidget.h"
#include <QMouseEvent>

FlatDropWidget::FlatDropWidget(QWidget *parent) : QDialog(parent)
{
    setWindowFlags(Qt::FramelessWindowHint);
    m_bPressedWidget = false;
}

void FlatDropWidget::mousePressEvent(QMouseEvent *e)
{
    m_lastPos = e->globalPos();
    m_bPressedWidget = true; // 当前鼠标按下的即是QWidget而非界面上布局的其它控件
}

void FlatDropWidget::mouseMoveEvent(QMouseEvent *e)
{
    if (m_bPressedWidget)
    {
        this->move(this->x() + (e->globalX() - m_lastPos.x()),
                   this->y() + (e->globalY() - m_lastPos.y()));
        m_lastPos = e->globalPos();
    }
}

void FlatDropWidget::mouseReleaseEvent(QMouseEvent *e)
{
    m_lastPos = e->globalPos();
    m_bPressedWidget = false; // 鼠标松开时，置为false
}
