#include "GlobalDef.h"
#include <kysecwhlist/kysec_whlist.h>
#include <kysec/status.h>
#include <kysec/libkyuser.h>
#include <unistd.h>
#include <sys/types.h>
#include <errno.h>
#include <pwd.h>
#include <grp.h>
#include <QDebug>

bool g_bAdmPrivilege = false;

QMap<int, QString> g_mapFileType;
QMap<int, QString> g_mapExectlSatus;
QMap<int, QString> g_mapFileProtectStatus;

GlobalDef::GlobalDef()
{

}

int get_exectl_status_type(int exectl, int status)
{
    if (status == 1)
        return exectl_status_distort;
    else    {
        if (exectl == exectl_sign_unknown)
            return exectl_status_unauth;
        else if (exectl == exectl_sign_verified)
            return exectl_status_verified;
        else
            return exectl_status_system;
    }
}

bool check_user_privilege()
{
    if (kysec_get_3adm_status())    {
        if (is_secadm())
            return true;
        else
            return false;
    }

    __uid_t uid = geteuid();
    if (uid == 0)
        return true;

    struct passwd *pwd = NULL;

    pwd = getpwuid((uid_t)uid);
    if (!pwd) {
        qDebug() << QString("Failed to get passwd struct for %1: %2\n").arg(uid).arg(strerror(errno)) << endl;
        return false;
    }

    const char *gname = "sudo";
    struct group *grp_info = NULL;
    int i = 0;

    grp_info = getgrnam(gname);
    if (!grp_info) {
        qDebug() << QString("Failed to get group for for %1: %2\n").arg(gname).arg(strerror(errno)) << endl;
        return false;
    }

    while (grp_info->gr_mem[i]) {
        if (strcmp(grp_info->gr_mem[i++], pwd->pw_name) == 0) {
            return true;
        }
    }

    return 0;
}
