#ifndef KYSECCONFIGUREDLG_H
#define KYSECCONFIGUREDLG_H

#include <QtWidgets/QWidget>
#include <QtWidgets/QTabWidget>
#include <QtWidgets/QLabel>
#include <QtWidgets/QPushButton>
#include <QtWidgets/QVBoxLayout>
#include <QtWidgets/QHBoxLayout>
#include "FlatDropWidget.h"
#include "KysecDataManage.h"
#include "TitleBar.h"


class KysecConfigureDlg : public QDialog
{
    Q_OBJECT
public:
    explicit KysecConfigureDlg(QWidget *parent = 0);
    ~KysecConfigureDlg();

signals:
    void signal_returnBtnClicked();
    void signal_minimizeBtnClicked();
    void signal_closeBtnClicked();

public slots:
    void slot_showDialog();
    void slot_tabChanged(int index);

private:
    void initUI();
    void initConnections();

private:
    TitleBar* m_pTitleBar;

    QTabWidget* m_pTabWidget;
    QHBoxLayout* m_pLayout;

    QLabel* m_pLabel;
    QHBoxLayout* m_pLabelLayout;

    QVBoxLayout* m_pMainLayout;    

    KysecDataManage* m_pExecCtrlManage;
    KysecDataManage* m_pFileProtectManage;
    KysecDataManage* m_pKmodProtectManage;
};

#endif // KYSECCONFIGUREDLG_H
