#include "KysecFileDialog.h"
#include <QtWidgets/QListView>
#include <QtWidgets/QTreeView>
#include <QtWidgets/QDialogButtonBox>
#include <QtWidgets/QLabel>
#include <QtWidgets/QPushButton>
#include <QtWidgets/QToolButton>
#include <QtWidgets/QAction>
#include <QDebug>
#include <QPalette>
#include <QPainter>

KysecFileDialog::KysecFileDialog(QWidget *parent) : QFileDialog(parent)
{        
    this->setOption(QFileDialog::DontUseNativeDialog,true);

    //支持多选
    QListView *pListView = this->findChild<QListView*>("listView");
    if (pListView)
        pListView->setSelectionMode(QAbstractItemView::ExtendedSelection);

    QTreeView *pTreeView = this->findChild<QTreeView*>();
    if (pTreeView)
        pTreeView->setSelectionMode(QAbstractItemView::ExtendedSelection);

    QDialogButtonBox *pButton = this->findChild<QDialogButtonBox *>("buttonBox");

    disconnect(pButton, SIGNAL(accepted()), this, SLOT(accept()));//使链接失效
    connect(pButton, SIGNAL(accepted()), this, SLOT(slot_selected()));//改成自己的槽

    QPalette palette = this->palette();
    palette.setColor(QPalette::ButtonText, Qt::black);
    QPushButton *pOpenBtn = pButton->button(QDialogButtonBox::Open);
    if (pOpenBtn)
    {
//        pOpenBtn->setText("添  加");
//        pOpenBtn->setProperty("class", "KysecFileDialogButton");
//        pOpenBtn->setText("选 择");
        pOpenBtn->setObjectName("KysecFileDialogButton");
        pOpenBtn->setFixedSize(75, 25);
        pOpenBtn->setPalette(palette);
    }

    QPushButton *pCancelBtn = pButton->button(QDialogButtonBox::Cancel);
    if (pCancelBtn)
    {
//        pCancelBtn->setProperty("class", "KysecFileDialogButton");
//        pCancelBtn->setText("取 消");
        pCancelBtn->setObjectName("KysecFileDialogButton");
        pCancelBtn->setFixedSize(75, 25);
        pCancelBtn->setPalette(palette);
    }

    QToolButton *pNewBtn = this->findChild<QToolButton *>("newFolderButton");
    if (pNewBtn)
    {
        pNewBtn->setVisible(false);
    }

    QAction *pNewAction = this->findChild<QAction *>("qt_new_folder_action");
    if (pNewAction)
    {
        pNewAction->setVisible(false);
    }

    pListView->setFocus();
}

void KysecFileDialog::slot_selected()
{
    QDialog::accept();
}

void KysecFileDialog::paintEvent(QPaintEvent *)
{
    QStyleOption opt;
    opt.init(this);
    QPainter p(this);
    style()->drawPrimitive(QStyle::PE_Widget, &opt, &p, this);
}
