#include "KysecFileProtectTableModel.h"
//#include <kysec_whlist/kysec_whlist.h>
#include "IconHelper.h"
#include "GlobalDef.h"
#include <QColor>

KysecFileProtectTableModel::KysecFileProtectTableModel(QObject *parent)
    : KysecTableModelBase(kysec_filepro, parent)
{
    m_typeFilters.clear();
    m_typeFilters.insert(object_program, true);
    m_typeFilters.insert(object_library, true);
    m_typeFilters.insert(object_script, true);
    m_typeFilters.insert(object_kmodule, true);
    m_typeFilters.insert(object_other, true);

    m_statusFilters.clear();    
    m_statusFilters.insert(filepro_sign_readonly, true);
    m_statusFilters.insert(filepro_sign_none, true);
}

KysecFileProtectTableModel::~KysecFileProtectTableModel()
{

}

QVariant KysecFileProtectTableModel::headerData(int section, Qt::Orientation orientation, int role) const
{
    if (role == Qt::DisplayRole)
    {
        if (orientation == Qt::Horizontal)
        {
            switch (section)
            {
            case 0:
                return QString("");
            case 1:
                return QString("文件路径");
            case 2:
                return QString("文件类型");
            case 3:
                //                return QString("当前状态");
                return QString("%1   %2").arg("当前状态").arg(QString(QChar(0xf0b0)));
            default:
                return QVariant();
            }
        }
    }

    if  (Qt::FontRole == role)
    {
        return IconHelper::Instance()->getFont(12);
    }

    if(orientation == Qt::Horizontal && role == Qt::TextAlignmentRole)
    {
        if (section != 1)
            return int(Qt::AlignCenter);
        else
            return int(Qt::AlignLeft | Qt::AlignVCenter);
    }

    return QVariant();
}

int KysecFileProtectTableModel::rowCount(const QModelIndex &parent) const
{
    //    if (!parent.isValid())
    //        return 0;

    Q_UNUSED(parent);

    return m_list.size();
}

int KysecFileProtectTableModel::columnCount(const QModelIndex &parent) const
{
    //    if (!parent.isValid())
    //        return 0;
    Q_UNUSED(parent);

    return 2;
}

//QVariant KysecFileProtectTableModel::data(const QModelIndex &index, int role) const
//{
//    if (!index.isValid())
//        return QVariant();

//    int col = index.column();
//    int row = index.row();

//    if (row > m_list.size() || row < 0)
//        return QVariant();

//    db_object temp = m_list.at(row).data;

//    if (Qt::DisplayRole == role)
//    {
//        if (col == 0)
//            if (m_list.at(row).checked)
//                return QString("%1 %2").arg(QString(QChar(0xf046))).arg(row + 1, 6, 10);
//            else
//                return QString("%1 %2").arg(QString(QChar(0xf096))).arg(row + 1, 6, 10);
//        else if (col == 1)
//            return temp.fpath;
//        else if (col == 2)
//            return g_mapFileType.value(temp.type);
//        else if (col == 3)
//            return g_mapFileProtectStatus.value(temp.filepro);
//        else
//            return QVariant();
//    }

//    if (Qt::TextAlignmentRole == role)
//    {
//        if (col != 1)
//            return (Qt::AlignCenter);
//        else
//            return int(Qt::AlignLeft + Qt::AlignVCenter);
//    }

//    if (Qt::TextColorRole == role)
//    {
//        if (g_bAdmPrivilege)
//        {
//            if (m_list.at(row).checked && col != 3)
//                return QColor("#0160D8");

//            if (col == 3)
//            {
//                if (m_list.at(row).data.filepro == filepro_sign_none)
//                    return QColor("#FF0000");
//                else
//                    return QColor("#000000");
//            }
//        }
//        else
//            return QColor("#A6A6A6");

//    }

//    return KysecTableModelBase::data(index, role);
//}
