#include "KysecFunctionWidget.h"

KysecFunctionWidget::KysecFunctionWidget(QWidget *parent) : QWidget(parent)
{
    initUI();
}

KysecFunctionWidget::~KysecFunctionWidget()
{

}

void KysecFunctionWidget::setText(QString name, QString desc, QString logo)
{
    m_pName->setText(name);
    m_pDesc->setText(desc);
    QPixmap pix(logo);
    m_pLogo->setPixmap(pix);
}

void KysecFunctionWidget::set_switchbtn_enabled(bool enabled)
{
    m_pSwitch->set_enabbled(enabled);
}

void KysecFunctionWidget::initUI()
{    
    setFixedSize(410, 80);

    QPalette palette = this->palette();
    QFont ft;

    m_pHLayout = new QHBoxLayout();
    m_pName = new QLabel(this);
    m_pSwitch = new KysecSwitchButton(this);
    m_pSwitch->setButtonStyle(KysecSwitchButton::ButtonStyle_CircleIn);

    palette.setColor(QPalette::WindowText, QColor("#121217"));
    ft.setPixelSize(18);
    m_pName->setFont(ft);
    m_pName->setPalette(palette);
    m_pName->setScaledContents(true);

    m_pHLayout->addWidget(m_pName);
    m_pHLayout->setSpacing(0);
    m_pHLayout->addSpacerItem(new QSpacerItem(90, 24, QSizePolicy::Expanding));
    m_pHLayout->addWidget(m_pSwitch);    
    m_pHLayout->setContentsMargins(0, 0, 0, 0);

    m_pVLayout = new QVBoxLayout();

    m_pDesc = new QLabel(this);
    palette.setColor(QPalette::WindowText, QColor("#66666F"));
    ft.setPixelSize(14);
    m_pDesc->setFont(ft);
    m_pDesc->setPalette(palette);
    m_pDesc->setScaledContents(true);

    m_pVLayout->setSpacing(12);
    m_pVLayout->addLayout(m_pHLayout);
    m_pVLayout->addWidget(m_pDesc);
    m_pVLayout->setContentsMargins(0, 15, 0, 15);

    m_pLayout = new QHBoxLayout();
    m_pLogo = new QLabel(this);
    m_pLogo->setFixedSize(50, 50);
    QHBoxLayout* layout = new QHBoxLayout();
    layout->addWidget(m_pLogo, 0, Qt::AlignCenter);

    m_pLayout->addWidget(m_pLogo);
    m_pLayout->setSpacing(24);
    m_pLayout->addLayout(m_pVLayout);
    m_pLayout->setStretch(0 , 1);
    m_pLayout->setStretch(1 , 3);
    m_pLayout->setContentsMargins(12, 0, 12, 0);

    setLayout(m_pLayout);
}
