#ifndef KYSECITEMDELEGATE_H
#define KYSECITEMDELEGATE_H

#include <QStyledItemDelegate>
#include "KysecTableModelBase.h"

class KysecItemDelegate : public QStyledItemDelegate
{
    Q_OBJECT
public:
    explicit KysecItemDelegate(int type, KysecTableModelBase *pModel, QWidget *parent = NULL);

signals:

protected:
    void paint(QPainter *painter,
               const QStyleOptionViewItem &option, const QModelIndex &index)    const;

    bool editorEvent(QEvent * event,
            QAbstractItemModel * model,
            const QStyleOptionViewItem & option,
            const QModelIndex & index);

public slots:
    void slot_hover_index_changed(QModelIndex index);
    void slot_selected_index_changed(QModelIndex index);

private:
    void drawBg(QPainter *painter, QRect rect, bool checked)    const;
    void drawSlider(QPainter *painter, QRect rect, bool checked)    const;
    void drawText(QPainter *painter, QRect rect, QString text, Qt::AlignmentFlag flag, QFont font, QColor color)    const;

private:
    int m_type;
    int m_space;

    KysecTableModelBase *m_pModel;

    QModelIndex m_hover_index;
    QModelIndex m_selected_index;    
};

#endif // KYSECITEMDELEGATE_H
