#ifndef KYSECMAINDLG_H
#define KYSECMAINDLG_H

#include <QtWidgets/QWidget>
#include <QtWidgets/QLabel>
#include <QPropertyAnimation>
#include <QtWidgets/QGraphicsOpacityEffect>
#include <QParallelAnimationGroup>

#include "KysecManageMain.h"

class KysecMainDlg : public QWidget
{
    Q_OBJECT
    Q_PROPERTY(QPointF AnimationPos READ getAnimationPos WRITE setAnimationPos)
    Q_PROPERTY(qreal AnimationOpacity READ getOpacity WRITE setOpacity)
public:
    explicit KysecMainDlg(QWidget *parent = 0);
    ~KysecMainDlg();

    void direct_enter_kysec_cfg_dialog();
    void startAnimation(void);

public:
    void setAnimationPos(const QPointF &a){ AnimationPos = a; this->move(a.x(), a.y());   }
    QPointF getAnimationPos(void){return AnimationPos;}

    qreal getOpacity(void){return  m_pEffect->opacity();    }
    void setOpacity(qreal opc){ m_pEffect->setOpacity(opc);  }

    QPropertyAnimation *InAnimation(void){return m_pInAnimation;}
    QPropertyAnimation *OutAnimation(void){return m_pOutAnimation;}

signals:
    void signal_showSettingDialog();
    void signal_showConfigureDialog();

    void signal_close();
    void signal_minimize();

private:
    void initUI();
    void initAnimation();

private:
    KysecManageMain* m_pKysecManageMain;
    QLabel* m_pBackgroundLabel;

private:
    QPropertyAnimation *m_pOutAnimation;
    QPropertyAnimation *m_pInAnimation;
    QPropertyAnimation *m_pOutOpacityAnimation;
    QPropertyAnimation *m_pInOpacityAnimation;
    QParallelAnimationGroup *m_pInGroup;
    QParallelAnimationGroup *m_pOutGroup;
    QGraphicsOpacityEffect *m_pEffect;

    QPointF AnimationPos;
    qreal AnimationOpacity;
    bool m_isOut;

};

#endif // KYSECMAINDLG_H
