#ifndef KYSECMANAGEMAIN_H
#define KYSECMANAGEMAIN_H

#include <QtWidgets/QWidget>
#include <QtWidgets/QVBoxLayout>
#include <QtWidgets/QHBoxLayout>
#include <QtWidgets/QLabel>
#include <QtWidgets/QPushButton>
#include <QtWidgets/QToolButton>
#include <QtDBus/QDBusConnection>
#include <QtDBus/QDBusReply>
#include <QtDBus/QDBusConnectionInterface>
#include <QDebug>

#include <QPropertyAnimation>
#include <QtWidgets/QGraphicsOpacityEffect>
#include <QParallelAnimationGroup>

#include "KysecLabelBtn.h"
#include "FlatDropWidget.h"
#include "TitleBar.h"
#include "AboutDialog.h"
#include "MainMenu.h"

class KysecManageMain : public QWidget
{
    Q_OBJECT

public:
    KysecManageMain(QWidget *parent = 0);
    ~KysecManageMain();

    void initKysecStatus();
    void enter_kysec_cfg_dialog();

private:
    void initUI();
    void initConnection();

    int daemonIsNotRunning();
    void showGuide(QString appName);

protected:
    bool eventFilter(QObject *watched, QEvent *event);
    void keyPressEvent(QKeyEvent *event);

private slots:
    void slot_showmenu();

    void slot_showNewCharacter();
    void slot_showAboutUs();

    void slot_settingBtnClicked();
    void slot_configBtnClicked();

signals:
    void signal_showSettingDialog();
    void signal_showConfigureDialog();

    void signal_close();
    void signal_minimize();

private:
    QHBoxLayout *m_pTitlebarLayout;
    QVBoxLayout *m_pLayout;

    TitleBar* m_pTitleBar;
    QLabel* m_pLogoLabel;
    QLabel* m_pMainLabel;
    QLabel* m_pDescLabel;
    QToolButton* m_pConfigToolBtn;

    QHBoxLayout* m_pBottomLayout;
    QLabel *m_pModeLabel;
    QLabel *m_pSpliteLabel;
    KysecLabelBtn* m_pSettingLabelBtn;

    MainMenu* m_pMainMenu;
    AboutDialog* m_pAboutDialog;
};

#endif // KYSECMANAGEMAIN_H
