#ifndef KYSECMESSAGEBOX_H
#define KYSECMESSAGEBOX_H

#include "FlatDropWidget.h"
#include "TitleBar.h"
#include <QTimer>

#include <QtWidgets/QHBoxLayout>
#include <QtWidgets/QVBoxLayout>
#include <QtWidgets/QLabel>
#include <QtWidgets/QPushButton>

enum MsgType
{
    Msg_Information = 0,
    Msg_Question,
    Msg_Warning,
    Msg_Complete,
};

class KysecMessageBox : public FlatDropWidget
{
    Q_OBJECT
public:
    explicit KysecMessageBox(QWidget *parent = 0);
    ~KysecMessageBox();

    int showMsg(MsgType type, QString msg);

private slots:
    void slot_okBtnClicked();
    void slot_timerout();

private:
    void initUI();

private:
    TitleBar *m_pTitleBar;

    QWidget* m_pWidget;
    QLabel* m_pIconLabel;
    QLabel *m_pLabel;

    QVBoxLayout* m_pVBoxLayout;

    QPushButton* m_pOKBtn;
    QPushButton* m_pCancelBtn;
    QHBoxLayout* m_pBottomLayout;

    QVBoxLayout* m_pMainLayout;

    QTimer *m_pTimer;
    int m_counter;

};

#endif // KYSECMESSAGEBOX_H
