#ifndef KYSECSETTINGDLG_H
#define KYSECSETTINGDLG_H

#include <QtWidgets/QLabel>
#include <QtWidgets/QPushButton>
#include <QtWidgets/QVBoxLayout>
#include <QtWidgets/QHBoxLayout>
#include <QtWidgets/QComboBox>
#include <QtWidgets/QGridLayout>
#include "FlatDropWidget.h"
#include "KysecFunctionWidget.h"
#include "TitleBar.h"

class KysecSettingDlg : public QDialog
{
    Q_OBJECT
public:
    KysecSettingDlg(QWidget *parent = 0);
    ~KysecSettingDlg();

private:
    void initUI();
    void initConnections();

signals:
    void signal_returnBtnClicked();
    void signal_minimizeBtnClicked();
    void signal_closeBtnClicked();

private slots:
    void slot_showDialog();
    void slot_comboBoxCurrentIndexChanged(int index);
    void slot_execCtrlStateChanged(bool checked);
    void slot_fileProtectStateChanged(bool checked);
    void slot_kmodProtectlStateChanged(bool checked);

private:
    TitleBar* m_pTitleBar;

    QLabel* m_pMainLabel;
    QLabel* m_pDescLabel;
    QLabel* m_pModeLabel;
    QComboBox* m_pModeComboBox;
    QHBoxLayout* m_pModeLayout;
    QHBoxLayout* m_pModeHLayout;
    QVBoxLayout* m_pModeVLayout;
    QWidget* m_pModeWidget;
    QWidget* m_pComboBoxModeWidget;

    KysecFunctionWidget* m_pExecCtrl;
    KysecFunctionWidget* m_pFileProtect;
    KysecFunctionWidget* m_pKModProtect;
    QGridLayout* m_pGridLayout;

    QVBoxLayout* m_pVLayout;
    QVBoxLayout* m_pMainLayout;

    QWidget* m_pExecCtrlWidget;
    QHBoxLayout* m_pExecCtrlLayout;

    QWidget* m_pFileProtectWidget;
    QHBoxLayout* m_pFileProtectLayout;

    QWidget* m_pKModProtectWidget;
    QHBoxLayout* m_pKModProtectLayout;

};

#endif // KYSECSETTINGDLG_H
