#ifndef KYSECTABLEMODELBASE_H
#define KYSECTABLEMODELBASE_H

#include <QAbstractTableModel>
#include <QList>

#include <kysecwhlist/kysec_whlist.h>
#include <kysecwhlist/kysec_file_type.h>

////kysec功能类型
//enum e_kysec_type
//{
//    kysec_exectrl = 0,			//执行控制
//    kysec_filepro,			//文件保护
//    kysec_kmodpro			//内核模块保护
//};

////kysec执行控制标记类型
//enum e_exectl_sign_type {
//    exectl_sign_original = 0,      //初始标记
//    exectl_sign_verified,          //认证标记
//    exectl_sign_kysoft,            //麒麟软件标记
//    exectl_sign_trusted,           //信任标记
//    exectl_sign_unknown            //未知、篡改标记
//};

////kysec文件保护标记类型
//enum e_filepro_sign_type  {
//    filepro_sign_readonly = 0,      //只读保护
//    filepro_sign_none               //无保护或被篡改
//};

struct whitelist_data
{
    bool checked;
    db_object data;
};

typedef struct stFilterItem
{
    QString item;
    bool checked;
}FilterItem;

class KysecTableModelBase : public QAbstractTableModel
{
    Q_OBJECT
public:
    KysecTableModelBase(int type, QObject *parent = 0);
    virtual ~KysecTableModelBase();

    void getRowData(int row, db_object &obj) const;
    void getWhlistData(int row, whitelist_data &obj)    const;
    void refreshData(const char* key = NULL);
    int deleteObjects();
    int updateObjects();
    int updateKoStatus(int row);
    int getCheckedCount()   const;

    QStringList getCheckedList();

    void updateChecked(int row);
    void setHoverRow(int row);
    int getHoverRow()   const {   return hover_row;   }

    void setTypeFilters(QMap<int, bool> typeFilters);
    void getTypeFilters(QMap<int, bool> &typeFilters);

    void setStatusFilters(QMap<int, bool> statusFilters);
    void getStatusFilters(QMap<int, bool> &statusFilters);

    void getStatisticsData(int &sum, int &distort);

signals:
    void signal_checkedStateChanged(int state);     //0  无选中， 1 半选，  2  全选
    void signal_checkedChanged(int count);
    void signal_updateKoStatusFailed(int res);

private slots:
    void slot_checkedStateChanged(int state);

protected:
    QVariant data(const QModelIndex &index, int role = Qt::DisplayRole) const ;
    void sort(int column, Qt::SortOrder order = Qt::AscendingOrder);

protected:
    void clearList();

protected:
    QList<whitelist_data> m_list;
    int m_type;

    QMap<int, bool> m_typeFilters;
    QMap<int, bool> m_statusFilters;

    int hover_row;
};

#endif // KYSECTABLEMODELBASE_H
