#include "KysecTableView.h"
#include <QMouseEvent>
#include <QtWidgets/QToolTip>
#include <QDebug>

KysecTableView::KysecTableView(QWidget *parent) : QTableView(parent)
{
    setMouseTracking(true);
}

void KysecTableView::setKysecModel(KysecTableModelBase *pModel)
{
    m_pModel = pModel;
}

void KysecTableView::mouseMoveEvent(QMouseEvent *event)
{
    QModelIndex index = indexAt(event->pos());
    emit signal_index_hovered(index);

//    int row = indexAt(event->pos()).row();
//    updateRow(row);

    if (!index.isValid() || index.column() != 1)
        QToolTip::hideText();

    QTableView::mouseMoveEvent(event);
}

void KysecTableView::leaveEvent(QEvent *event)
{
    emit signal_index_hovered(QModelIndex());
    QTableView::leaveEvent(event);
//    m_pModel->setHoverRow(-1);
//    int column_count= model()->columnCount();
//    for (int i = column_count- 1; i >= 0; i--)
//    {
//        update(model()->index(current_row, i));
//    }
//    current_row = -1;
//    QTableView::leaveEvent(event);
}

void KysecTableView::updateRow(int row)
{
    if (row == current_row)
        return;

    m_pModel->setHoverRow(row);
    int column_count= model()->columnCount();
    for (int i = column_count- 1; i >= 0; i--)
    {
        update(model()->index(current_row, i));
        update(model()->index(row, i));
    }

    current_row = row;
}
