#include "MainMenu.h"

MainMenu::MainMenu(QWidget *widget)
	: QMenu(widget)
{
	this->createActions();    
    this->setObjectName("menu");
}

MainMenu::~MainMenu()
{    
    delete m_pActionNewCharacter; //新版特性
    delete m_pActionSysetmSetting;
    delete m_pActionCheckUpdate; //检查更新
    delete m_pActionPlatformHelp; //论坛求助
    delete m_pActionLoginHome; //
    delete m_pActionProtect; //隐私保护
    delete m_pActionAboutUs; //关于我们
}

void MainMenu::createActions()
{
	//创建菜单项    
    m_pActionNewCharacter = new QAction("用户手册", this);
    m_pActionSysetmSetting = new QAction("状态设置", this);
    m_pActionCheckUpdate = new QAction("检查更新", this);
    m_pActionPlatformHelp = new QAction("社区论坛", this);
    m_pActionLoginHome = new QAction("银河麒麟首页", this);
    m_pActionProtect = new QAction("隐私保护", this);
    m_pActionAboutUs = new QAction("关于", this);

	//添加菜单项
    this->addAction(m_pActionNewCharacter);
    this->addAction(m_pActionCheckUpdate);
    this->addAction(m_pActionSysetmSetting);
	this->addSeparator();
    this->addAction(m_pActionPlatformHelp);
    this->addAction(m_pActionLoginHome);
    this->addAction(m_pActionProtect);
    this->addAction(m_pActionAboutUs);

    m_pActionPlatformHelp->setObjectName(QString::number(PLATFORM_HELP, 10));
    m_pActionLoginHome->setObjectName(QString::number(LOGIN_HOME, 10));
    m_pActionAboutUs->setObjectName(QString::number(PROTECT, 10));

	//设置信号连接   
    connect(m_pActionNewCharacter, SIGNAL(triggered()), this, SIGNAL(signal_showNewCharacter()));
    connect(m_pActionSysetmSetting, SIGNAL(triggered()), this, SIGNAL(signal_systemSetting()));
    connect(m_pActionAboutUs, SIGNAL(triggered()), this, SIGNAL(signal_showAboutUs()));
    connect(m_pActionPlatformHelp, SIGNAL(triggered()), this, SLOT(slot_showPage()));
    connect(m_pActionLoginHome, SIGNAL(triggered()), this, SLOT(slot_showPage()));
    connect(m_pActionProtect, SIGNAL(triggered()), this, SLOT(slot_showPage()));

    m_pActionCheckUpdate->setVisible(false);
    m_pActionPlatformHelp->setVisible(false);
    m_pActionLoginHome->setVisible(false);
    m_pActionProtect->setVisible(false);
}

void MainMenu::slot_showPage()
{
	QObject *object = QObject::sender();  
    QAction * action = qobject_cast<QAction * >(object);
	QString object_name = action->objectName();
	int index = object_name.toInt();
	QString page;
	switch(index)
	{
	case HELP_ONLINE:
        page = QString("https://www.ubuntukylin.com/ukylin/forum.php");
		break;

	case PLATFORM_HELP:
        page = QString("https://www.ubuntukylin.com/ukylin/forum.php");
		break;

	case LOGIN_HOME:
        page = QString("http://www.kylinos.cn/");
		break;

	case PROTECT:
        page = QString("http://www.kylinos.cn/");
		break;

	default:
		break;
	}

	 QUrl url(page);
	 QDesktopServices::openUrl(url);
}
