#include "ProcessUpdateWaitingDialog.h"
#include "unistd.h"
#include <kysecwhlist/kysec_whlist.h>
#include <kysecwhlist/kysec_file_type.h>

ProcessUpdateWaitingDialog::ProcessUpdateWaitingDialog(QWidget *parent) : WaitingDialogBase(1, parent)
{
    setText(QString("KYSEC 白名单更新"), QString("记录更新中..."));
}

ProcessUpdateWaitingDialog::~ProcessUpdateWaitingDialog()
{

}

void ProcessUpdateWaitingDialog::setPathList(int type, QStringList list)
{
    m_type = type;
    m_list = list;
}

int ProcessUpdateWaitingDialog::processEvent()
{
    char **list = NULL;
    int count = m_list.size();
    if (count == 0)
    {
        setResult(-99);
        return 0;
    }

    list = (char **)malloc(count * sizeof(char *));
    for (int i = 0; i < m_list.size(); i++)
    {
        list[i] = strdup(m_list.at(i).toLocal8Bit().data());
    }

    int ret = kysec_whlist_updates(m_type, list, count);
    if (ret != 0)
    {
        QString dbus_err = QString(kysec_whlist_last_err());
        QString err;
        switch (ret) {
        case 1:
        case 2:
            err = QString("授权认证失败,禁止更新!");
            break;
        case 3:
            err = QString("KYSEC安全机制未启用,禁止更新!");
            break;
        case 4:
            err = QString("数据库异常,更新白名单记录失败!");
            break;
        case 5:
            err = QString("%1 :获取文件标记失败!").arg(dbus_err.split(":").at(0));
            break;
        case 6:
            err = QString("%1 :设置文件标记失败!").arg(dbus_err.split(":").at(0));
            break;
        case 7:
            err = QString("无效参数，更新白名单记录失败!").arg(dbus_err.split(":").at(0));
            break;
        case 8:
            err = QString("%1 :获取待更新文件列表失败!").arg(dbus_err.split(":").at(0));
            break;
        case 9:
            err = QString("%1 :文件属性异常!").arg(dbus_err.split(":").at(0));
            break;
        default:
            err = QString("未知错误,更新白名单记录失败!");
            break;
        }

        set_error_msg(err);
    }
    for (int i = 0; i < count; i++)
    {
        free(list[i]);
    }
    free(list);

    setResult(ret);
    return 0;
}
