#ifndef TITLEBAR_H
#define TITLEBAR_H

#include <QtWidgets/QWidget>
#include <QtWidgets/QHBoxLayout>
#include <QtWidgets/QPushButton>
#include <QtWidgets/QLabel>

class TitleBar : public QWidget
{
    Q_OBJECT
public:
    explicit TitleBar(QWidget *parent = 0);
    ~TitleBar();

    QPushButton *getCloseBtn() const {return m_pCloseBtn;}
    QPushButton *getMinimizeBtn() const {return m_pMinimizeBtn;}
    QPushButton *getMenuBtn() const {return m_pMenuBtn;}
    QPushButton *getReturnBtn() const {return m_pReturnBtn;}

    void setLogoIcon(QString icon);
    void setCloseIcon(QString icon);
    void hideLogo();
    void setLogoLabel(QString text, int size = 0, QString color = "");
    void setBackgroundColor(QString color);
    void InsertUserLayout(QLayout *UserLayout, int pos, int stretch);
    void InsertUserWidget(QWidget *widget, int index, int stretch = 0, Qt::Alignment alignment = 0);

protected:
//    virtual void paintEvent(QPaintEvent*);

private:
    void WidgetLayoutInit(void);

private:
    QPushButton *m_pCloseBtn;
    QPushButton *m_pMinimizeBtn;
    QPushButton *m_pMenuBtn;
    QPushButton *m_pReturnBtn;

    QLabel *m_pLogo;
    QLabel *m_pLabel;

    QHBoxLayout *m_pToolhlayout;
};


#endif // TITLEBAR_H
